<?php

class ResourceHandler {

	function ResourceHandler() {
	}
		
	function serveSpecificResource( &$site, &$pathParts, $pathDepth, &$smarty) {

		global $SITE_LOCATION;

		if( isset($_SERVER['HTTP_IF_MODIFIED_SINCE']) ) {
			header('Last-Modified: ' . $_SERVER['HTTP_IF_MODIFIED_SINCE'], true, 304);
			exit;
		}

		//*** WHEN CACHING CSS/JAVASCRIPT/ becareful to cache with local:
		//*** "/cached/homepage_en.css" or "/cached/homepage_en-gb-london.css"
		
		// seconds, minutes, hours, days
		//$expires = 60*60*24*14;	//14 days
		if( isset( $site[CSM_RESOURCE_CACHING]) && $site[CSM_RESOURCE_CACHING]) {
			
			if( isset( $site[CSM_RESOURCE_CACHE_DAYS]) ) {
				$expires = 60 * 60 * 24 * $site[CSM_RESOURCE_CACHE_DAYS]; //n days
			} else {
				$expires = 60 * 60 * 1;	//1 hour
			}

			header("Pragma: public");
			header("Cache-Control: maxage=" . $expires);
			header('Expires: ' . gmdate('D, d M Y H:i:s', time() + $expires) . ' GMT');
		}
		
		//HANDLE CSS:
		if( CSS === $pathParts[1]) {

			session_write_close();
			$resourceName = null;
			for( $i = 2; $i < $pathDepth; $i++) {
				$resourceName .= $pathParts[ $i] . '/';
			}
			$posOfLastDot = strripos( $pathParts[ $pathDepth], '.');
			$resourceName .= substr( $pathParts[ $pathDepth], 0, $posOfLastDot);
			$resourceExtension = substr( $pathParts[ $pathDepth], $posOfLastDot + 1);
			
			if( array_key_exists(CSM_CSS_SETS, $site) && isset( $site[CSM_CSS_SETS] ) && !empty( $site[CSM_CSS_SETS]) ) {
				//we have a CSM_CSS_SETS config
				if( isset( $site[CSM_CSS_SETS][$resourceName] ) && !empty( $site[CSM_CSS_SETS][$resourceName] ) ) {
					
					//build an 'assembled' version:
					$sessionFilePart = '';
					if( !empty( $_SESSION['locale']) ) {
						$sessionFilePart = '_' . $_SESSION['locale'];
					}

					$cssCacheDirectory = $SITE_LOCATION . '/_cache/' . CSS . '/';
					if( !file_exists( $cssCacheDirectory) ) {
						//make css cache directory:
						mkdir( $cssCacheDirectory, 0700, true);
					}
					
					$assembledCSSFile = $cssCacheDirectory . $resourceName . $sessionFilePart . '.css';

					if( !file_exists( $assembledCSSFile) || ( isset( $site[CSM_CSS_SET_CACHING]) && $site[CSM_CSS_SET_CACHING] === false)) {

						//build content and create assembled file:
						
						//and it contains an entry for this resource name
						$cssSetArray = $site[CSM_CSS_SETS][$resourceName];
						
						$assembledCSSContent = '';
						foreach( $cssSetArray as $setCSSName) {
							$posOfLastDot = strripos( $setCSSName, '.');
							$cssScriptExtension = substr( $setCSSName, $posOfLastDot + 1);
							$setCSSName = substr( $setCSSName, 0, $posOfLastDot);
							
							$cssDataFiles = getAllLocaleFileNames( $SITE_LOCATION . '/resources/' . CSS . '/' . $setCSSName, $_SESSION['locale'], '.' . $cssScriptExtension);
							
							foreach( $cssDataFiles as $filePath) {
								$assembledCSSContent .= file_get_contents( $filePath);	//add a semi-colon to terminate any statements
							}
						}
						if( !empty( $assembledCSSContent) ) {

							//compress and tidy CSS:
							
							if( false === array_key_exists( CSM_CSS_DISABLE_OPTIMIZATION, $site) || $site[CSM_CSS_DISABLE_OPTIMIZATION] === false) {

								global $CONTENTIGO_LOCATION;
								require_once( $CONTENTIGO_LOCATION . '/lib/csstidy-1.3-modified/class.csstidy.php');
								$cssTidy = new csstidy();
	
								$cssTidy->set_cfg('preserve_css',true);
				/*				
								$cssTidy->set_cfg('--preserve_css',false);
								$cssTidy->set_cfg('--remove_bslash',false);
								$cssTidy->set_cfg('--compress_colors',false);
								$cssTidy->set_cfg('--lowercase_s',false);
								$cssTidy->set_cfg('--timestamp',false);
								$cssTidy->set_cfg('--optimise_shorthands',false);	// 0|1|2
								$cssTidy->set_cfg('--sort_properties',false);
								$cssTidy->set_cfg('--sort_selectors',false);
								$cssTidy->set_cfg('--merge_selectors',false);	// 0|1|2
								$cssTidy->set_cfg('--compress_font-weight',false);
								$cssTidy->set_cfg('--allow_html_in_templates',false);
								$cssTidy->set_cfg('--silent',true);
								$cssTidy->set_cfg('--case_properties',false);	// 0|1|2
								$cssTidy->set_cfg('--sort_selectors',false);
								$cssTidy->set_cfg('--template','highest');	[default | filename | low | high | highest] | output_filename ]
								$cssTidy->set_cfg('remove_last_;',true);
				*/				
				
								$cssTidy->parse( $assembledCSSContent);
								//Logger::log( "css compression ratio: " . $cssTidy->print->get_ratio() . "%" );
								$assembledCSSContent = $cssTidy->print->plain();
							}
							
							file_put_contents( $assembledCSSFile, $assembledCSSContent);
						}
						
					}

					//must set headers before we send output
 					header('Content-type: text/css');
					$fileModifyTime = filemtime( $assembledCSSFile);
					header('Last-Modified: ' . gmdate('D, d M Y H:i:s', $fileModifyTime) . ' GMT');
					readfile( $assembledCSSFile);
					exit;
				}


			}
			
			//for css we want all the locale files:
			//$cssDataFiles = getAllLocaleFileNames( $SITE_LOCATION . '/resources/' . CSS . '/' . $resourceName, $site['DEFAULT_LOCALE'], '.' . $resourceExtension . '.css');
			$cssDataFiles = getAllLocaleFileNames( $SITE_LOCATION . '/resources/' . CSS . '/' . $resourceName, $_SESSION['locale'], '.' . $resourceExtension);

 			header('Content-type: text/css');
			if( empty( $cssDataFiles) ) {
				//we got nothing, let's see if a template .tpl exists:
				$cssDataFiles = getAllLocaleFileNames( $SITE_LOCATION . '/resources/' . CSS . '/' . $resourceName, $_SESSION['locale'], '.' . $resourceExtension . '.tpl');
				foreach( $cssDataFiles as $filePath) {
					$smarty->display( $filePath);
				}
			} else {
				foreach( $cssDataFiles as $filePath) {
		 			readfile( $filePath);
				}
			}
			
			exit;
		}
		
		if( JAVASCRIPT === $pathParts[1]) {
			session_write_close();
			$resourceName = null;
			for( $i = 2; $i < $pathDepth; $i++) {
				$resourceName .= $pathParts[ $i] . '/';
			}
			$posOfLastDot = strripos( $pathParts[ $pathDepth], '.');
			$resourceName .= substr( $pathParts[ $pathDepth], 0, $posOfLastDot);
			$resourceExtension = substr( $pathParts[ $pathDepth], $posOfLastDot + 1);

			if( array_key_exists(CSM_SCRIPT_SETS, $site) && isset( $site[CSM_SCRIPT_SETS] ) && !empty( $site[CSM_SCRIPT_SETS]) ) {
				//we have a CSM_SCRIPT_SETS config
				if( isset( $site[CSM_SCRIPT_SETS][$resourceName] ) && !empty( $site[CSM_SCRIPT_SETS][$resourceName] ) ) {
					//and it contains an entry for this resource name
					
					//build an 'assembled' version:
					$sessionFilePart = '';
					if( !empty( $_SESSION['locale']) ) {
						$sessionFilePart = '_' . $_SESSION['locale'];
					}
					
					$scriptCacheDirectory = $SITE_LOCATION . '/_cache/' . JAVASCRIPT . '/';
					if( !file_exists( $scriptCacheDirectory) ) {
						//make css cache directory:
						mkdir( $scriptCacheDirectory, 0700, true);
					}
					
					$assembledScriptFile = $scriptCacheDirectory . $resourceName . $sessionFilePart . '.js';

					if( !file_exists( $assembledScriptFile) || ( isset( $site[CSM_SCRIPT_SET_CACHING]) && $site[CSM_SCRIPT_SET_CACHING] === false) ) {
						
						$scriptSetArray = $site[CSM_SCRIPT_SETS][$resourceName];
						
						$assembledScriptContent = '';
						foreach( $scriptSetArray as $setScriptName) {			
							$posOfLastDot = strripos( $setScriptName, '.');
							$setScriptExtension = substr( $setScriptName, $posOfLastDot + 1);
							$setScriptName = substr( $setScriptName, 0, $posOfLastDot);
	
							$javascriptDataFiles = getAllLocaleFileNames( $SITE_LOCATION . '/resources/' . JAVASCRIPT . '/' . $setScriptName, $_SESSION['locale'], '.' . $setScriptExtension);
							foreach( $javascriptDataFiles as $filePath) {
								$assembledScriptContent .= file_get_contents( $filePath) . ';';	//add a semi-colon to terminate any statements
							}
						}

						if( !empty( $assembledScriptContent) ) {
							//minify scritpt:
							global $CONTENTIGO_LOCATION;
							require_once( $CONTENTIGO_LOCATION . '/lib/jsmin-1.1.2.php');
							$minifiedScript = JSMin::minify( $assembledScriptContent);
							file_put_contents( $assembledScriptFile, $minifiedScript);
						}
					}

					//must set headers before we send output
					header('Content-type: application/javascript');
					$fileModifyTime = filemtime( $assembledScriptFile);
					header('Last-Modified: ' . gmdate('D, d M Y H:i:s', $fileModifyTime) . ' GMT');
					readfile( $assembledScriptFile);
					exit;
				}

				
			}
			
			//for javascript we want all the locale files:
			$javascriptDataFiles = getAllLocaleFileNames( $SITE_LOCATION . '/resources/' . JAVASCRIPT . '/' . $resourceName, $_SESSION['locale'], '.' . $resourceExtension);
 			header('Content-type: application/javascript');
 			
 			$mostRecentFileModifyTime = PHP_INT_MAX;
			foreach( $javascriptDataFiles as $filePath) {
	 			$thisFileModifyTime = filemtime($filePath);
	 			if( $thisFileModifyTime < $mostRecentFileModifyTime) {
	 				$mostRecentFileModifyTime = $thisFileModifyTime;
	 			}
			}
			//must set headers before we send output
			header('Last-Modified: ' . gmdate('D, d M Y H:i:s', $mostRecentFileModifyTime) . ' GMT');
			foreach( $javascriptDataFiles as $filePath) {
	 			readfile( $filePath);
			}
			exit;
		}

		if( IMAGES === $pathParts[1]) {
			session_write_close();
			$resourceName = null;
			for( $i = 2; $i < $pathDepth; $i++) {
				$resourceName .= $pathParts[ $i] . '/';
			}
		  	
			$posOfLastDot = strripos( $pathParts[ $pathDepth], '.');
			$resourceName .= substr( $pathParts[ $pathDepth], 0, $posOfLastDot);
			$resourceExtension = substr( $pathParts[ $pathDepth], $posOfLastDot + 1);

			$resourceFileName = getLocaleFileName( $SITE_LOCATION . '/resources/' . IMAGES . '/' . $resourceName, $_SESSION['locale'], '.' . $resourceExtension);

			global $EXTENSION_CONTENT_TYPE_MAP;
			if( isset( $EXTENSION_CONTENT_TYPE_MAP[ $resourceExtension] ) ) {
	 			header('Content-type: ' . $EXTENSION_CONTENT_TYPE_MAP[ $resourceExtension]);
			}
			
			header('Last-Modified: ' . gmdate('D, d M Y H:i:s', filemtime($resourceFileName)) . ' GMT');
 			readfile( $resourceFileName);
			exit;
		}

/*		if( FONTS === $pathParts[1]) {
			$resourceName = null;
			for( $i = 1; $i < $pathDepth; $i++) {
				$resourceName .= $pathParts[ $i] . '/';
			}
			$posOfLastDot = strripos( $pathParts[ $pathDepth], '.');
			$resourceName .= substr( $pathParts[ $pathDepth], 0, $posOfLastDot);
			$resourceExtension = substr( $pathParts[ $pathDepth], $posOfLastDot + 1);
			
			//for css we want all the locale files:
			$resourceFileName = getLocaleFileName( $SITE_LOCATION . '/resources/' . FONTS . '/' . $resourceName, $site['DEFAULT_LOCALE'], '.' . $resourceExtension);
			logVar( $resourceFileName);
			if( isset( $EXTENSION_CONTENT_TYPE_MAP[ $resourceExtension] ) ) {
	 			header('Content-type: ' . $EXTENSION_CONTENT_TYPE_MAP[ $resourceExtension]);
			}
			header('Last-Modified: ' . gmdate('D, d M Y H:i:s', filemtime($resourceFileName)) . ' GMT');
 			readfile( $resourceFileName);
			exit;
		}*/
	}


	function serveGeneralResource( &$site, &$pathParts, $pathDepth, &$smarty) {
		
		//handle simple resource types
		session_write_close();
		if( isset($_SERVER['HTTP_IF_MODIFIED_SINCE']) ) {
			header('Last-Modified: ' . $_SERVER['HTTP_IF_MODIFIED_SINCE'], true, 304);
			exit;
		}

		$resourceName = null;
		for( $i = 2; $i < $pathDepth; $i++) {
			$resourceName .= $pathParts[ $i] . '/';
		}
		$posOfLastDot = strripos( $pathParts[ $pathDepth], '.');
		$resourceName .= substr( $pathParts[ $pathDepth], 0, $posOfLastDot);
		$resourceExtension = substr( $pathParts[ $pathDepth], $posOfLastDot + 1);

		global $SITE_LOCATION;
		$resourceFileName = getLocaleFileName( $SITE_LOCATION . '/resources/' . $pathParts[1] . '/' . $resourceName, $_SESSION['locale'], '.' . $resourceExtension);

		global $EXTENSION_CONTENT_TYPE_MAP;
		if( isset( $EXTENSION_CONTENT_TYPE_MAP[ $resourceExtension] ) ) {
			outputFile( $resourceFileName, $EXTENSION_CONTENT_TYPE_MAP[ $resourceExtension]);
		} else {
			outputFile( $resourceFileName);
			//a 'default' type?
		}
	
	}

}

?>
